--- old/usr/src/lib/libm/common/m9x/fmax.c	2014-05-04 03:06:34.957958649 +0200
+++ new/usr/src/lib/libm/common/m9x/fmax.c	2014-05-04 03:06:35.202981665 +0200
@@ -58,17 +58,12 @@
 	if (x != x)
 		x = y;
 
-	/* if x is less than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x < y)
-#else
-	if (!isgreaterequal(x, y))
-#endif
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !isgreaterequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; clear the
-	 * sign of the result if either x or y has its sign clear
+	 * clear the sign of the result if either x or y has its sign clear
 	 */
 	xx.d = x;
 	yy.d = y;
--- old/usr/src/lib/libm/common/m9x/fmaxf.c	2014-05-04 03:06:36.918424451 +0200
+++ new/usr/src/lib/libm/common/m9x/fmaxf.c	2014-05-04 03:06:36.949437226 +0200
@@ -127,17 +127,12 @@
 	if (x != x)
 		x = y;
 
-	/* if x is less than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x < y)
-#else
-	if (!isgreaterequal(x, y))
-#endif
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !isgreaterequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; clear the
-	 * sign of the result if either x or y has its sign clear
+	 * clear the sign of the result if either x or y has its sign clear
 	 */
 	xx.f = x;
 	yy.f = y;
--- old/usr/src/lib/libm/common/m9x/fmaxl.c	2014-05-04 03:06:38.433878046 +0200
+++ new/usr/src/lib/libm/common/m9x/fmaxl.c	2014-05-04 03:06:38.461931870 +0200
@@ -51,17 +51,16 @@
 	if (y != y)
 		y = x;
 
-	/* if x is less than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x != x || x < y)
-#else
-	if (!isgreaterequal(x, y))
-#endif
+	/* if x is nan, replace it by y */
+	if (x != x)
+		x = y;
+
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !isgreaterequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; clear the
-	 * sign of the result if either x or y has its sign clear
+	 * clear the sign of the result if either x or y has its sign clear
 	 */
 	xx.ld = x;
 	yy.ld = y;
--- old/usr/src/lib/libm/common/m9x/fmin.c	2014-05-04 03:06:39.230656496 +0200
+++ new/usr/src/lib/libm/common/m9x/fmin.c	2014-05-04 03:06:39.259578599 +0200
@@ -41,6 +41,8 @@
 
 #include "libm.h"	/* for islessequal macro */
 
+#include "fenv_inlines.h"
+#include <stdio.h>
 #include <sys/isa_defs.h>
 
 double
@@ -50,7 +52,7 @@
 		double d;
 	} xx, yy;
 	unsigned s;
-
+	
 	/* if y is nan, replace it by x */
 	if (y != y)
 		y = x;
@@ -59,17 +61,12 @@
 	if (x != x)
 		x = y;
 
-	/* if x is greater than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x != x || x > y)
-#else
-	if (!islessequal(x, y))
-#endif
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !islessequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; set the
-	 * sign of the result if either x or y has its sign set
+	 * set the sign of the result if either x or y has its sign set
 	 */
 	xx.d = x;
 	yy.d = y;
--- old/usr/src/lib/libm/common/m9x/fminf.c	2014-05-04 03:06:40.750780777 +0200
+++ new/usr/src/lib/libm/common/m9x/fminf.c	2014-05-04 03:06:40.994481746 +0200
@@ -86,17 +86,12 @@
 	if (x != x)
 		x = y;
 
-/* if x is greater than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x > y)
-#else
-	if (!islessequal(x, y))
-#endif
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !islessequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; set the
-	 * sign of the result if either x or y has its sign set
+	 * set the sign of the result if either x or y has its sign set
 	 */
 	xx.f = x;
 	yy.f = y;
--- old/usr/src/lib/libm/common/m9x/fminl.c	2014-05-04 03:06:43.033018327 +0200
+++ new/usr/src/lib/libm/common/m9x/fminl.c	2014-05-04 03:06:43.063122525 +0200
@@ -51,17 +51,16 @@
 	if (y != y)
 		y = x;
 
-	/* if x is greater than y or x and y are unordered, replace x by y */
-#if defined(COMPARISON_MACRO_BUG)
-	if (x != x || x > y)
-#else
-	if (!islessequal(x, y))
-#endif
+	/* if x is nan, replace it by y */
+	if (x != x)
+		x = y;
+
+	/* At this point, x and y are either both numeric, or both NaN */
+	if (!isnan(x) && !islessequal(x, y))
 		x = y;
 
 	/*
-	 * now x and y are either both NaN or both numeric; set the
-	 * sign of the result if either x or y has its sign set
+	 * set the sign of the result if either x or y has its sign set
 	 */
 	xx.ld = x;
 	yy.ld = y;
--- old/usr/src/lib/libm/common/m9x/llrintl.c	2014-05-04 03:06:44.440435197 +0200
+++ new/usr/src/lib/libm/common/m9x/llrintl.c	2014-05-04 03:06:44.667613689 +0200
@@ -56,8 +56,7 @@
 		unsigned i;
 		float f;
 	} tt;
-	unsigned int hx, sx, frac;
-	unsigned int fsr;
+	unsigned int hx, sx, frac, fsr;
 	int rm, j;
 	volatile float dummy;
 
--- old/usr/src/lib/libm/common/m9x/lrintl.c	2014-05-04 03:06:46.772542518 +0200
+++ new/usr/src/lib/libm/common/m9x/lrintl.c	2014-05-04 03:06:46.579540653 +0200
@@ -43,15 +43,14 @@
 long
 lrintl(long double x) {
 	union {
-		unsigned i[4];
+		unsigned int i[4];
 		long double q;
 	} xx;
 	union {
-		unsigned i;
+		unsigned int i;
 		float f;
 	} tt;
-	unsigned hx, sx, frac, l;
-	unsigned int fsr;
+	unsigned int hx, sx, frac, l, fsr;
 	int rm, j;
 	volatile float dummy;
 
--- old/usr/src/lib/libm/common/m9x/nan.c	2014-05-04 03:06:48.500452919 +0200
+++ new/usr/src/lib/libm/common/m9x/nan.c	2014-05-04 03:06:48.530339124 +0200
@@ -38,20 +38,22 @@
 #include "libm.h"
 #include <sys/isa_defs.h>
 
-#if defined(_BIG_ENDIAN)
+#if defined(__sparc)
 
 static const union {
 	unsigned i[2];
 	double d;
 } __nan_union = { 0x7fffffff, 0xffffffff };
 
-#else
+#elif defined(__i386) || defined(__amd64)
 
 static const union {
 	unsigned i[2];
 	double d;
 } __nan_union = { 0xffffffff, 0x7fffffff };
 
+#else
+#error Unknown architecture
 #endif
 
 /* ARGSUSED0 */
--- old/usr/src/lib/libm/common/m9x/nearbyint.c	2014-05-04 03:06:49.809079553 +0200
+++ new/usr/src/lib/libm/common/m9x/nearbyint.c	2014-05-04 03:06:50.051983432 +0200
@@ -100,9 +100,9 @@
 			return (x);
 		xx.i[LOWORD] = 0;
 		xx.i[HIWORD] &= ~(i - 1);
-		if (rm == FE_UPWARD || (rm == FE_TONEAREST &&
-			(frac > 0x80000000u || (frac == 0x80000000) &&
-			(xx.i[HIWORD] & i))))
+		if ((rm == FE_UPWARD) || ((rm == FE_TONEAREST) &&
+			((frac > 0x80000000u) || ((frac == 0x80000000) &&
+			(xx.i[HIWORD] & i)))))
 			xx.i[HIWORD] += i;
 	} else {
 		i = 1 << j;
@@ -110,9 +110,9 @@
 		if (!frac)
 			return (x);
 		xx.i[LOWORD] &= ~(i - 1);
-		if (rm == FE_UPWARD || (rm == FE_TONEAREST &&
-			(frac > 0x80000000u || (frac == 0x80000000) &&
-			(xx.i[LOWORD] & i)))) {
+		if ((rm == FE_UPWARD) || ((rm == FE_TONEAREST) &&
+			(frac > 0x80000000u || ((frac == 0x80000000) &&
+			(xx.i[LOWORD] & i))))) {
 			xx.i[LOWORD] += i;
 			if (xx.i[LOWORD] == 0)
 				xx.i[HIWORD]++;
--- old/usr/src/lib/libm/common/m9x/nearbyintf.c	2014-05-04 03:06:51.960166730 +0200
+++ new/usr/src/lib/libm/common/m9x/nearbyintf.c	2014-05-04 03:06:51.990180860 +0200
@@ -80,7 +80,7 @@
 
 	hx &= ~(i - 1);
 	if (rm == FE_UPWARD || (rm == FE_TONEAREST && (frac > (i >> 1) ||
-		(frac == (i >> 1)) && (hx & i))))
+		((frac == (i >> 1)) && (hx & i)))))
 		xx.i = sx | (hx + i);
 	else
 		xx.i = sx | hx;
--- old/usr/src/lib/libm/common/m9x/tgamma.c	2014-05-04 03:06:55.281784015 +0200
+++ new/usr/src/lib/libm/common/m9x/tgamma.c	2014-05-04 03:06:55.310990734 +0200
@@ -1406,7 +1406,7 @@
 /* gamma(x+i) for 0 <= x < 1  */
 static struct Double
 gam_n(int i, double x) {
-	struct Double rr, yy;
+	struct Double rr = {0.0L, 0.0L}, yy;
 	double r1, r2, t2, z, xh, xl, yh, yl, zh, z1, z2, zl, x5, wh, wl;
 
 	/* compute yy = gamma(x+1) */
@@ -1558,7 +1558,7 @@
 		__HI(w) += m << 20;
 		return (w);
 	}
-	if (hx > 0) {		/* x from 0 to 8 */
+	if (hx > 0) {		/* 0 < x < 8 */
 		i = (int) x;
 		ww = gam_n(i, x - (double) i);
 		return (ww.h + ww.l);
--- old/usr/src/lib/libm/common/m9x/tgammaf.c	2014-05-04 03:06:56.478434198 +0200
+++ new/usr/src/lib/libm/common/m9x/tgammaf.c	2014-05-04 03:06:56.509854424 +0200
@@ -400,7 +400,7 @@
  */
 static double
 gam_n(int i, double x) {
-	double rr, yy;
+	double rr = 0.0L, yy;
 	double z1, z2;
 
 	/* compute yy = gamma(x+1) */
@@ -472,7 +472,7 @@
 	if (hx >= 0x41000000)	/* x >= 8 */
 		return ((float) large_gam(x));
 
-	if (hx > 0) {		/* x from 0 to 8 */
+	if (hx > 0) {		/* 0 < x < 8 */
 		i = (int) xf;
 		return ((float) gam_n(i, x - (double) i));
 	}
--- old/usr/src/lib/libm/common/m9x/tgammal.c	2014-05-04 03:06:58.441863388 +0200
+++ new/usr/src/lib/libm/common/m9x/tgammal.c	2014-05-04 03:06:58.472010301 +0200
@@ -881,7 +881,7 @@
  */
 static struct LDouble
 gam_n(int i, long double x) {
-	struct LDouble rr, yy;
+	struct LDouble rr = {0.0L, 0.0L}, yy;
 	long double r1, r2, t2, z, xh, xl, yh, yl, zh, z1, z2, zl, x5, wh, wl;
 
 	/* compute yy = gamma(x+1) */
@@ -1032,7 +1032,7 @@
 		return (scalbnl(w, m));
 	}
 
-	if (hx > 0) {		/* x from 0 to 8 */
+	if (hx > 0) {		/* 0 < x < 8 */
 		i = (int) x;
 		ww = gam_n(i, x - (long double) i);
 		return (ww.h + ww.l);
--- old/usr/src/lib/libm/i386/src/libm_inlines.h	2014-05-04 03:06:59.843458973 +0200
+++ new/usr/src/lib/libm/i386/src/libm_inlines.h	2014-05-04 03:06:59.874117579 +0200
@@ -28,7 +28,7 @@
  * Copyright 2011, Richard Lowe
  */
 
-/* Functions in this file are duplicated in libm.m4.  Keep them in sync */
+/* Functions in this file are duplicated in locallibm.il.  Keep them in sync */
 
 #ifndef _LIBM_INLINES_H
 #define	_LIBM_INLINES_H
@@ -47,30 +47,18 @@
 #define	_HIER_WORD(x)	((uint32_t *)&x)[2]
 
 extern __inline__ double
-__ieee754_sqrt(double a)
-{
-	double ret;
-
-	__asm__ __volatile__("fsqrt\n\t" : "=t" (ret) : "0" (a));
-	return (ret);
-}
-
-extern __inline__ double
 __inline_sqrt(double a)
 {
 	double ret;
 
-	__asm__ __volatile__("fsqrt\n\t" : "=t" (ret) : "0" (a));
+	__asm__ __volatile__("fsqrt\n\t" : "=t" (ret) : "0" (a) : "cc");
 	return (ret);
 }
 
 extern __inline__ double
-__d_sqrt_(double *a)
+__ieee754_sqrt(double a)
 {
-	double ret;
-
-	__asm__ __volatile__("fsqrt\n\t" : "=t" (ret) : "0" (*a));
-	return (ret);
+	return (__inline_sqrt(a));
 }
 
 extern __inline__ float
@@ -78,34 +66,24 @@
 {
 	float ret;
 
-	__asm__ __volatile__("fsqrt\n\t" : "=t" (ret) : "0" (a));
+	__asm__ __volatile__("fsqrt\n\t" : "=t" (ret) : "0" (a) : "cc");
 	return (ret);
 }
 
 extern __inline__ double
 __inline_rint(double a)
 {
-	double ret;
-
 	__asm__ __volatile__(
-		"andl $0x7fffffff,%2\n\t"
-		"cmpl $0x43300000,%2\n\t"
-		"jae  1f\n\t"
-		"frndint\n\t"
-		"1: fwait\n\t"
-		: "=t" (ret)
-                : "0" (a), "r" (_HI_WORD(a)));
-
-	return (ret);
-}
-
-extern __inline__ short
-__inline_fstsw(void)
-{
-	short ret;
+	    "andl $0x7fffffff,%1\n\t"
+	    "cmpl $0x43300000,%1\n\t"
+	    "jae  1f\n\t"
+	    "frndint\n\t"
+	    "1: fwait\n\t"
+	    : "+t" (a), "+&r" (_HI_WORD(a))
+	    :
+	    : "cc");
 
-	__asm__ __volatile__("fstsw %0\n\t" : "=r" (ret));
-	return (ret);
+	return (a);
 }
 
 /*
@@ -155,24 +133,24 @@
 extern __inline__ double
 ceil(double d)
 {
-	double ret;
 	short rd = __swap87RD(fp_positive);
 
-	__asm__ __volatile__("frndint" : "=t" (ret) : "0" (d));
+	__asm__ __volatile__("frndint" : "+t" (d), "+r" (rd) : : "cc");
 	__swap87RD(rd);
 
-	return (ret);
+	return (d);
 }
 
 extern __inline__ double
 copysign(double d1, double d2)
 {
 	__asm__ __volatile__(
-	    "andl $0x7fffffff,%0\n\t" /* %0 <-- hi_32(abs(d)) */
-	    "andl $0x80000000,%1\n\t" /* %1[31] <-- sign_bit(d2) */
-	    "orl  %1,%0\n\t"	      /* %0 <-- hi_32(copysign(x,y)) */
-	    : "+r" (_HI_WORD(d1))
-	    : "r" (_HI_WORD(d2)));
+	    "andl $0x7fffffff,%0\n\t"	/* %0 <-- hi_32(abs(d)) */
+	    "andl $0x80000000,%1\n\t"	/* %1[31] <-- sign_bit(d2) */
+	    "orl  %1,%0\n\t"		/* %0 <-- hi_32(copysign(x,y)) */
+	    : "+&r" (_HI_WORD(d1)), "+r" (_HI_WORD(d2))
+	    :
+	    : "cc");
 
 	return (d1);
 }
@@ -180,150 +158,85 @@
 extern __inline__ double
 fabs(double d)
 {
-	double ret;
-
-	__asm__ __volatile__("fabs\n\t" : "=t" (ret) : "0" (d));
-	return (ret);
+	__asm__ __volatile__("fabs\n\t" : "+t" (d) : : "cc");
+	return (d);
 }
 
 extern __inline__ float
 fabsf(float d)
 {
-	float ret;
-
-	__asm__ __volatile__("fabs\n\t" : "=t" (ret) : "0" (d));
-	return (ret);
+	__asm__ __volatile__("fabs\n\t" : "+t" (d) : : "cc");
+	return (d);
 }
 
 extern __inline__ long double
 fabsl(long double d)
 {
-	long double ret;
-
-	__asm__ __volatile__("fabs\n\t" : "=t" (ret) : "0" (d));
-	return (ret);
+	__asm__ __volatile__("fabs\n\t" : "+t" (d) : : "cc");
+	return (d);
 }
 
 extern __inline__ int
 finite(double d)
 {
-	int ret;
+	int ret = _HI_WORD(d);
 
 	__asm__ __volatile__(
-	    "notl %1\n\t"
-	    "andl $0x7ff00000,%1\n\t"
-	    "negl %1\n\t"
-	    "shrl $31,%1\n\t"
-	    : "=r" (ret)
-	    : "0" (_HI_WORD(d)));
+	    "notl %0\n\t"
+	    "andl $0x7ff00000,%0\n\t"
+	    "negl %0\n\t"
+	    "shrl $31,%0\n\t"
+	    : "+r" (ret)
+	    :
+	    : "cc");
 	return (ret);
 }
 
 extern __inline__ double
 floor(double d)
 {
-	double ret;
 	short rd = __swap87RD(fp_negative);
 
-	__asm__ __volatile__("frndint" : "=t" (ret) : "0" (d));
+	__asm__ __volatile__("frndint" : "+t" (d), "+r" (rd) : : "cc");
 	__swap87RD(rd);
 
-	return (ret);
-}
-
-/*
- *	branchless __isnan
- *	((0x7ff00000-[((lx|-lx)>>31)&1]|ahx)>>31)&1 = 1 iff x is NaN
- */
-extern __inline__ int
-isnan(double d)
-{
-	int ret;
-
-	__asm__ __volatile__(
-	"movl %1,%%ecx\n\t"
-	"negl %%ecx\n\t"	  /* ecx <-- -lo_32(x) */
-	"orl  %%ecx,%1\n\t"
-	"shrl $31,%1\n\t"	  /* 1 iff lx != 0 */
-	"andl $0x7fffffff,%2\n\t" /* ecx <-- hi_32(abs(x)) */
-	"orl  %2,%1\n\t"
-	"subl $0x7ff00000,%1\n\t"
-	"negl %1\n\t"
-	"shrl $31,%1\n\t"
-	: "=r" (ret)
-	: "0" (_HI_WORD(d)), "r" (_LO_WORD(d))
-	: "ecx");
-
-	return (ret);
+	return (d);
 }
 
 extern __inline__ int
 isnanf(float f)
 {
-	int ret;
-
 	__asm__ __volatile__(
 	    "andl $0x7fffffff,%0\n\t"
 	    "negl %0\n\t"
 	    "addl $0x7f800000,%0\n\t"
 	    "shrl $31,%0\n\t"
-	    : "=r" (ret)
-	    : "0" (f));
+	    : "+r" (f)
+	    :
+	    : "cc");
 
-	return (ret);
-}
-
-extern __inline__ int
-isinf(double d)
-{
-	int ret;
-
-	__asm__ __volatile__(
-	"andl $0x7fffffff,%1\n\t"	    /* set first bit to 0 */
-	"cmpl $0x7ff00000,%1\n\t"
-	"pushfl\n\t"
-	"popl %0\n\t"
-	"cmpl $0,%2\n\t"		/* is lo_32(x) = 0? */
-	"pushfl\n\t"
-	"popl %2\n\t"	/* bit 6 of ecx <-- lo_32(x) == 0 */
-	"andl %2,%0\n\t"
-	"andl $0x40,%0\n\t"
-	"shrl $6,%0\n\t"
-	: "=r" (ret)
-	: "0" (_HI_WORD(d)), "r" (_LO_WORD(d)));
-
-	return (ret);
+	return (f);
 }
 
 extern __inline__ double
 rint(double a) {
-	double ret;
-
-	__asm__ __volatile__(
-		"andl $0x7fffffff,%2\n\t"
-		"cmpl $0x43300000,%2\n\t"
-		"jae  1f\n\t"
-		"frndint\n\t"
-		"1: fwait\n\t"
-		: "=t" (ret)
-		: "0" (a), "r" (_HI_WORD(a)));
-
-	return (ret);
+    return (__inline_rint(a));
 }
 
 extern __inline__ double
 scalbn(double d, int n)
 {
-	double ret, dummy;
+	double dummy;
 
 	__asm__ __volatile__(
-	    "fildl %3\n\t"	/* Convert N to extended */
+	    "fildl %2\n\t"	/* Convert N to extended */
 	    "fxch\n\t"
 	    "fscale\n\t"
-	    : "=t" (ret), "=u" (dummy)
-	    : "0" (d), "m" (n));
+	    : "+t" (d), "=u" (dummy)
+	    : "m" (n)
+	    : "cc");
 
-	return (ret);
+	return (d);
 }
 
 extern __inline__ int
@@ -341,54 +254,50 @@
 extern __inline__ double
 sqrt(double d)
 {
-	double ret;
-	__asm__ __volatile__("fsqrt" : "=t" (ret) : "0" (d));
-	return (ret);
+	return (__inline_sqrt(d));
 }
 
 extern __inline__ float
 sqrtf(float f)
 {
-	float ret;
-	__asm__ __volatile__("fsqrt" : "=t" (ret) : "0" (f));
-	return (ret);
+	return (__inline_sqrtf(f));
 }
 
 extern __inline__ long double
 sqrtl(long double ld)
 {
-	long double ret;
-	__asm__ __volatile__("fsqrt" : "=t" (ret) : "0" (ld));
-	return (ret);
+	__asm__ __volatile__("fsqrt" : "+t" (ld) : : "cc");
+	return (ld);
 }
 
 extern __inline__ int
 isnanl(long double ld)
 {
-        int ret;
+	int ret = _HIER_WORD(ld);
 
-        __asm__ __volatile__(
-            "andl  $0x00007fff,%1\n\t"
-            "jz	   1f\n\t"             /* jump if __exp is all 0 */
-	    "xorl  $0x00007fff,%1\n\t"
-            "jz	   2f\n\t"             /* jump if __exp is all 1 */
-	    "testl $0x80000000,%2\n\t"
-	    "jz	   3f\n\t"             /* jump if leading bit is 0 */
-	    "movl  $0,%1\n\t"
+	__asm__ __volatile__(
+	    "andl  $0x00007fff,%0\n\t"
+	    "jz	   1f\n\t"		/* jump if exp is all 0 */
+	    "xorl  $0x00007fff,%0\n\t"
+	    "jz	   2f\n\t"		/* jump if exp is all 1 */
+	    "testl $0x80000000,%1\n\t"
+	    "jz	   3f\n\t"		/* jump if leading bit is 0 */
+	    "movl  $0,%0\n\t"
 	    "jmp   1f\n\t"
-            "2:\n\t"                   /* note that %eax = 0 from before */
-            "cmpl  $0x80000000,%2\n\t" /* what is first half of __significand? */
-	    "jnz   3f\n\t"	       /* jump if not equal to 0x80000000 */
-	    "testl $0xffffffff,%3\n\t" /* is second half of __significand 0? */
-	    "jnz   3f\n\t"	       /* jump if not equal to 0 */
+	    "2:\n\t"			/* note that %0 = 0 from before */
+	    "cmpl  $0x80000000,%1\n\t"	/* what is first half of significand? */
+	    "jnz   3f\n\t"		/* jump if not equal to 0x80000000 */
+	    "testl $0xffffffff,%2\n\t"	/* is second half of significand 0? */
+	    "jnz   3f\n\t"		/* jump if not equal to 0 */
 	    "jmp   1f\n\t"
-            "3:\n\t"
-            "movl  $1,%1\n\t"
-            "1:\n\t"
-            : "=r" (ret)
-            : "0" (_HIER_WORD(ld)), "r" (_HI_WORD(ld)), "r" (_LO_WORD(ld)));
+	    "3:\n\t"
+	    "movl  $1,%0\n\t"
+	    "1:\n\t"
+	    : "+&r" (ret)
+	    : "r" (_HI_WORD(ld)), "r" (_LO_WORD(ld))
+	    : "cc");
 
-        return (ret);
+	return (ret);
 }
 
 #ifdef __cplusplus
--- old/usr/src/lib/libm/i386/src/locallibm.il	2014-05-04 03:07:01.612189818 +0200
+++ new/usr/src/lib/libm/i386/src/locallibm.il	2014-05-04 03:07:01.428628389 +0200
@@ -217,24 +217,6 @@
 	addl	$8,%esp
 	.end
 
-/
-/	branchless __isnan
-/	((0x7ff00000-[((lx|-lx)>>31)&1]|ahx)>>31)&1 = 1 iff x is NaN
-/
-	.inline	__isnan,0
-	movl	(%esp),%eax		/// eax <-- lo_32(x)
-	movl	%eax,%ecx
-	negl	%ecx			/ ecx <-- -lo_32(x)
-	orl	%ecx,%eax
-	shrl	$31,%eax		/ 1 iff lx != 0
-	movl	4(%esp),%ecx		/// ecx <-- hi_32(x)
-	andl	$0x7fffffff,%ecx	/ ecx <-- hi_32(abs(x))
-	orl	%ecx,%eax
-	subl	$0x7ff00000,%eax
-	negl	%eax
-	shrl	$31,%eax
-	.end
-
 	.inline	__isnanf,0
 	movl	(%esp),%eax
 	andl	$0x7fffffff,%eax
@@ -243,19 +225,6 @@
 	shrl	$31,%eax
 	.end
 
-	.inline	__isinf,0
-	movl	4(%esp),%eax		/ eax <-- hi_32(x)
-	andl    $0x7fffffff,%eax        / set first bit to 0
-	cmpl    $0x7ff00000,%eax
-	pushfl
-	popl    %eax
-	cmpl    $0,(%esp)		/ is lo_32(x) = 0?
-	pushfl
-	popl    %ecx			/ bit 6 of ecx <-- lo_32(x) == 0
-	andl    %ecx,%eax
-	andl    $0x40,%eax
-	shrl    $6,%eax
-	.end
 
 	.inline	__isnormal,0
 					/ TRUE iff (x is _finite, but
--- old/usr/src/lib/libm/sparc/src/libm_inlines.h	2014-05-04 03:07:03.997456310 +0200
+++ new/usr/src/lib/libm/sparc/src/libm_inlines.h	2014-05-04 03:07:04.236358665 +0200
@@ -28,7 +28,7 @@
  * Copyright 2011, Richard Lowe.
  */
 
-/* Functions in this file are duplicated in libm.m4.  Keep them in sync */
+/* Functions in this file are duplicated in locallibm.il.  Keep them in sync */
 
 #ifndef _LIBM_INLINES_H
 #define	_LIBM_INLINES_H
@@ -47,7 +47,7 @@
 {
 	double ret;
 
-	__asm__ __volatile__("fsqrtd %0,%0\n\t" : "=e" (ret) : "0" (d));
+	__asm__ __volatile__("fsqrtd %1,%0\n\t" : "=e" (ret) : "e" (d));
 	return (ret);
 }
 
@@ -56,7 +56,7 @@
 {
 	float ret;
 
-	__asm__ __volatile__("fsqrts %0,%0\n\t" : "=f" (ret) : "0" (f));
+	__asm__ __volatile__("fsqrts %1,%0\n\t" : "=f" (ret) : "f" (f));
 	return (ret);
 }
 
@@ -64,47 +64,49 @@
 fp_classf(float f)
 {
 	enum fp_class_type ret;
+	uint32_t tmp;
 
+	/* XXX: Separate input and output */
 	__asm__ __volatile__(
-	    "sethi  %%hi(0x80000000),%%o2\n\t"
-	    "andncc %0,%%o2,%0\n\t"
+	    "sethi  %%hi(0x80000000),%1\n\t"
+	    "andncc %3,%1,%0\n\t"
 	    "bne    1f\n\t"
 	    "nop\n\t"
 	    "mov    0,%0\n\t"
-	    "ba	2f\n\t"             /* x is 0 */
+	    "ba	2f\n\t"		/* x is 0 */
 	    "nop\n\t"
 	    "1:\n\t"
-	    "sethi  %%hi(0x7f800000),%%o2\n\t"
-	    "andcc  %0,%%o2,%%g0\n\t"
+	    "sethi  %%hi(0x7f800000),%1\n\t"
+	    "andcc  %0,%1,%%g0\n\t"
 	    "bne    1f\n\t"
 	    "nop\n\t"
 	    "mov    1,%0\n\t"
-	    "ba	    2f\n\t"	    /* x is subnormal */
+	    "ba	    2f\n\t"	/* x is subnormal */
 	    "nop\n\t"
 	    "1:\n\t"
-	    "cmp    %0,%%o2\n\t"
+	    "cmp    %0,%1\n\t"
 	    "bge    1f\n\t"
 	    "nop\n\t"
 	    "mov    2,%0\n\t"
-	    "ba	    2f\n\t"	    /* x is normal */
+	    "ba	    2f\n\t"	/* x is normal */
 	    "nop\n\t"
 	    "1:\n\t"
 	    "bg	    1f\n\t"
 	    "nop\n\t"
 	    "mov    3,%0\n\t"
-	    "ba	    2f\n\t"	    /* x is __infinity */
+	    "ba	    2f\n\t"	/* x is __infinity */
 	    "nop\n\t"
 	    "1:\n\t"
-	    "sethi  %%hi(0x00400000),%%o2\n\t"
-	    "andcc  %0,%%o2,%%g0\n\t"
-	    "mov    4,%0\n\t"       /* x is quiet NaN */
+	    "sethi  %%hi(0x00400000),%1\n\t"
+	    "andcc  %0,%1,%%g0\n\t"
+	    "mov    4,%0\n\t"	/* x is quiet NaN */
 	    "bne    2f\n\t"
 	    "nop\n\t"
-	    "mov    5,%0\n\t"       /* x is signaling NaN */
+	    "mov    5,%0\n\t"	/* x is signaling NaN */
 	    "2:\n\t"
-	    : "=r" (ret)
-	    : "0" (f)
-	    : "o2");
+	    : "+r" (ret), "=&r" (tmp)
+	    : "r" (f)
+	    : "cc");
 	return (ret);
 }
 
@@ -115,53 +117,54 @@
 fp_class(double d)
 {
 	enum fp_class_type ret;
+	uint32_t tmp;
 
 	__asm__ __volatile__(
-	    "sethi %%hi(0x80000000),%%o2\n\t" /* o2 gets 80000000 */
-	    "andn  %0,%%o2,%0\n\t"	      /* o0-o1 gets abs(x) */
-	    "orcc  %0,%2,%%g0\n\t"	      /* set cc as x is zero/nonzero */
-	    "bne   1f\n\t"		      /* branch if x is nonzero */
+	    "sethi %%hi(0x80000000),%1\n\t"	/* %1 gets 80000000 */
+	    "andn  %2,%1,%0\n\t"		/* %2-%0 gets abs(x) */
+	    "orcc  %0,%3,%%g0\n\t"		/* set cc as x is zero/nonzero */
+	    "bne   1f\n\t"			/* branch if x is nonzero */
 	    "nop\n\t"
 	    "mov   0,%0\n\t"
-	    "ba	   2f\n\t"		      /* x is 0 */
+	    "ba	   2f\n\t"			/* x is 0 */
 	    "nop\n\t"
 	    "1:\n\t"
-	    "sethi %%hi(0x7ff00000),%%o2\n\t" /* o2 gets 7ff00000 */
-	    "andcc %0,%%o2,%%g0\n\t"	      /* cc set by __exp field of x */
-	    "bne   1f\n\t"		      /* branch if normal or max __exp */
+	    "sethi %%hi(0x7ff00000),%1\n\t"	/* %1 gets 7ff00000 */
+	    "andcc %0,%1,%%g0\n\t"		/* cc set by __exp field of x */
+	    "bne   1f\n\t"			/* branch if normal or max __exp */
 	    "nop\n\t"
 	    "mov   1,%0\n\t"
-	    "ba	   2f\n\t"		      /* x is subnormal */
+	    "ba	   2f\n\t"			/* x is subnormal */
 	    "nop\n\t"
 	    "1:\n\t"
-	    "cmp   %0,%%o2\n\t"
-	    "bge   1f\n\t"		      /* branch if x is max __exp */
+	    "cmp   %0,%1\n\t"
+	    "bge   1f\n\t"			/* branch if x is max __exp */
 	    "nop\n\t"
 	    "mov   2,%0\n\t"
-	    "ba	   2f\n\t"		      /* x is normal */
+	    "ba	   2f\n\t"			/* x is normal */
 	    "nop\n\t"
 	    "1:\n\t"
-	    "andn  %0,%%o2,%0\n\t"	      /* o0 gets msw __significand field */
-	    "orcc  %0,%2,%%g0\n\t"	      /* set cc by OR __significand */
-	    "bne   1f\n\t"		      /* Branch if __nan */
+	    "andn  %0,%1,%0\n\t"		/* o0 gets msw __significand field */
+	    "orcc  %0,%3,%%g0\n\t"		/* set cc by OR __significand */
+	    "bne   1f\n\t"			/* Branch if __nan */
 	    "nop\n\t"
 	    "mov   3,%0\n\t"
-	    "ba	   2f\n\t"		      /* x is __infinity */
+	    "ba	   2f\n\t"			/* x is __infinity */
 	    "nop\n\t"
 	    "1:\n\t"
-	    "sethi %%hi(0x00080000),%%o2\n\t"
-	    "andcc %0,%%o2,%%g0\n\t"	      /* set cc by quiet/sig bit */
-	    "be	   1f\n\t"		      /* Branch if signaling */
+	    "sethi %%hi(0x00080000),%1\n\t"
+	    "andcc %0,%1,%%g0\n\t"		/* set cc by quiet/sig bit */
+	    "be	   1f\n\t"			/* Branch if signaling */
 	    "nop\n\t"
-	    "mov   4,%0\n\t"		      /* x is quiet NaN */
+	    "mov   4,%0\n\t"			/* x is quiet NaN */
 	    "ba	   2f\n\t"
 	    "nop\n\t"
 	    "1:\n\t"
-	    "mov   5,%0\n\t"		      /* x is signaling NaN */
+	    "mov   5,%0\n\t"			/* x is signaling NaN */
 	    "2:\n\t"
-	    : "=r" (ret)
-	    : "0" (_HI_WORD(d)), "r" (_LO_WORD(d))
-	    : "o2");
+	    : "=&r" (ret), "=&r" (tmp)
+	    : "r" (_HI_WORD(d)), "r" (_LO_WORD(d))
+	    : "cc");
 
 	return (ret);
 }
@@ -171,23 +174,24 @@
 {
 	int ret;
 	uint32_t fsr;
+	uint32_t tmp1, tmp2;
 
 	__asm__ __volatile__(
-	    "and  %0,0x1f,%%o1\n\t"
-	    "sll  %%o1,5,%%o1\n\t"    /*  input to aexc bit location */
+	    "and  %4,0x1f,%3\n\t"
+	    "sll  %3,5,%3\n\t"	/* shift input to aexc bit location */
 	    ".volatile\n\t"
-	    "st   %%fsr,%2\n\t"
-	    "ld   %2,%0\n\t"          /* = fsr */
-	    "andn %0,0x3e0,%%o2\n\t"
-	    "or   %%o1,%%o2,%%o1\n\t" /* o1 = new fsr */
-	    "st	  %%o1,%2\n\t"
-	    "ld	  %2,%%fsr\n\t"
+	    "st   %%fsr,%1\n\t"
+	    "ld   %1,%0\n\t"	/* %0 = fsr */
+	    "andn %0,0x3e0,%4\n\t"
+	    "or   %3,%4,%3\n\t"	/* %3 = new fsr */
+	    "st	  %3,%1\n\t"
+	    "ld	  %1,%%fsr\n\t"
 	    "srl  %0,5,%0\n\t"
 	    "and  %0,0x1f,%0\n\t"
 	    ".nonvolatile\n\t"
-	    : "=r" (ret)
-	    : "0" (i), "m" (fsr)
-	    : "o1", "o2");
+	    : "=r" (ret), "=m" (fsr), "=r" (tmp1), "=r" (tmp2)
+	    : "r" (i)
+	    : "cc");
 
 	return (ret);
 }
@@ -208,24 +212,25 @@
 {
 	enum fp_direction_type ret;
 	uint32_t fsr;
+	uint32_t tmp1, tmp2, tmp3;
 
 	__asm__ __volatile__(
-	    "and  %0,0x3,%0\n\t"
-	    "sll  %0,30,%%o1\n\t"      /* input to RD bit location */
+	    "and  %5,0x3,%0\n\t"
+	    "sll  %0,30,%2\n\t"		/* shift input to RD bit location */
 	    ".volatile\n\t"
-	    "st   %%fsr,%2\n\t"
-	    "ld	  %2,%0\n\t"           /* o0 = fsr */
-	    "set  0xc0000000,%%o4\n\t" /* mask of rounding direction bits */
-	    "andn %0,%%o4,%%o2\n\t"
-	    "or   %%o1,%%o2,%%o1\n\t"  /* o1 = new fsr */
-	    "st	  %%o1,%2\n\t"
-	    "ld	  %2,%%fsr\n\t"
+	    "st   %%fsr,%1\n\t"
+	    "ld	  %1,%0\n\t"		/* %0 = fsr */
+	    "set  0xc0000000,%4\n\t"	/* mask of rounding direction bits */
+	    "andn %0,%4,%3\n\t"
+	    "or   %2,%3,%2\n\t"		/* %2 = new fsr */
+	    "st	  %2,%1\n\t"
+	    "ld	  %1,%%fsr\n\t"
 	    "srl  %0,30,%0\n\t"
 	    "and  %0,0x3,%0\n\t"
 	    ".nonvolatile\n\t"
-	    : "=r" (ret)
-	    : "0" (d), "m" (fsr)
-	    : "o1", "o2", "o4");
+	    : "=r" (ret), "=m" (fsr), "=r" (tmp1), "=r" (tmp2), "=r" (tmp3)
+	    : "r" (d)
+	    : "cc");
 
 	return (ret);
 }
@@ -234,25 +239,25 @@
 __swapTE(int i)
 {
 	int ret;
-	uint32_t fsr;
-	
+	uint32_t fsr, tmp1, tmp2;
+
 	__asm__ __volatile__(
-	    "and  %0,0x1f,%0\n\t"
-	    "sll  %0,23,%%o1\n\t"      /* input to TEM bit location */
+	    "and  %4,0x1f,%0\n\t"
+	    "sll  %0,23,%2\n\t"		/* shift input to TEM bit location */
 	    ".volatile\n\t"
-	    "st   %%fsr,%2\n\t"
-	    "ld	  %2,%0\n\t"           /* o0 = fsr */
-	    "set  0x0f800000,%%o4\n\t" /* mask of TEM (Trap Enable Mode bits) */
-	    "andn %0,%%o4,%%o2\n\t"	  
-	    "or   %%o1,%%o2,%%o1\n\t"  /* o1 = new fsr */
-	    "st	  %%o1,%2\n\t"
-	    "ld	  %2,%%fsr\n\t"
+	    "st   %%fsr,%1\n\t"
+	    "ld	  %1,%0\n\t"		/* %0 = fsr */
+	    "set  0x0f800000,%%o4\n\t"	/* mask of TEM (Trap Enable Mode bits) */
+	    "andn %0,%%o4,%3\n\t"
+	    "or   %2,%3,%2\n\t"		/* %2 = new fsr */
+	    "st	  %2,%1\n\t"
+	    "ld	  %1,%%fsr\n\t"
 	    "srl  %0,23,%0\n\t"
 	    "and  %0,0x1f,%0\n\t"
 	    ".nonvolatile\n\t"
-	    : "=r" (ret)
-	    : "0" (i), "m" (fsr)
-	    : "o1", "o2", "o4");
+	    : "=r" (ret), "=m" (fsr), "=r" (tmp1), "=r" (tmp2)
+	    : "r" (i)
+	    : "cc");
 
 	return (ret);
 }
@@ -260,37 +265,31 @@
 extern __inline__ double
 sqrt(double d)
 {
-    double ret;
-
-    __asm__ __volatile__("fsqrtd %0,%0\n\t" : "=f" (ret) : "0" (d));
-    return (ret);
+	return (__inline_sqrt(d));
 }
 
 extern __inline__ float
 sqrtf(float f)
 {
-    float ret;
-
-    __asm__ __volatile__("fsqrts %0,%0\n\t" : "=f" (ret) : "0" (f));
-    return (ret);
+	return (__inline_sqrtf(f));
 }
 
 extern __inline__ double
 fabs(double d)
 {
-    double ret;
+	double ret;
 
-    __asm__ __volatile__("fabsd %0,%0\n\t" : "=e" (ret) : "0" (d));
-    return (ret);
+	__asm__ __volatile__("fabsd %1,%0\n\t" : "=e" (ret) : "e" (d));
+	return (ret);
 }
 
 extern __inline__ float
 fabsf(float f)
 {
-    float ret;
+	float ret;
 
-    __asm__ __volatile__("fabss %0,%0\n\t" : "=f" (ret) : "0" (f));
-    return (ret);
+	__asm__ __volatile__("fabss %1,%0\n\t" : "=f" (ret) : "f" (f));
+	return (ret);
 }
 
 #ifdef __cplusplus
--- old/usr/src/lib/libm/sparc/src/locallibm.il	2014-05-04 03:07:06.445664244 +0200
+++ new/usr/src/lib/libm/sparc/src/locallibm.il	2014-05-04 03:07:06.472946966 +0200
@@ -752,7 +752,7 @@
 
 	.inline	__swapEX,1
 	and     %o0,0x1f,%o1
-	sll     %o1,5,%o1               !  input to aexc bit location
+	sll     %o1,5,%o1               ! shift input to aexc bit location
 	.volatile
 	st      %fsr,[%sp+0x44]
 	ld      [%sp+0x44],%o0          ! o0 = fsr
@@ -777,7 +777,7 @@
 
 	.inline	__swapRD,1
 	and	%o0,0x3,%o0
-	sll     %o0,30,%o1              !  input to RD bit location
+	sll     %o0,30,%o1              ! shift input to RD bit location
 	.volatile
 	st      %fsr,[%sp+0x44]
 	ld      [%sp+0x44],%o0          ! o0 = fsr
@@ -800,7 +800,7 @@
 
 	.inline	__swapTE,1
 	and	%o0,0x1f,%o0
-	sll     %o0,23,%o1              !  input to TEM bit location
+	sll     %o0,23,%o1              ! shift input to TEM bit location
 	.volatile
 	st      %fsr,[%sp+0x44]
 	ld      [%sp+0x44],%o0            ! o0 = fsr
